from operator import *
from functools import reduce, partial
import random

# @author SoundOfSpouting
# @template T
# @param {Iterable<T>} it
# @param {T -> void} callback
foreach = (lambda it, callback:
  (foreach_(iter(it), callback)))

foreach_ = (lambda it, callback:
  (el := next(it, None),
   el and (callback(el), foreach(it, callback))))

# @author SoundOfSpouting
# @param {number} x
# @param {number} y
Coordinate = type("Coordinate", (), dict(
  __init__ = (lambda self, x, y:
    (setattr(self, "x", x),                                                                                                                                                         (
     setattr(self, "y", y)))                                                                                                                                                        and None)
  ,
  # @author SoundOfSpouting
  # @returns {string}
  __str__ = (lambda self: 
    ("%X%d" % (self.y + 10, self.x))),

  # @author SoundOfSpouting
  # @returns {number}
  getX = (lambda self: 
    (self.x)),

  # @author SoundOfSpouting
  # @returns {number}
  getY = (lambda self: 
    (self.y)),

  add = (lambda self, other:
    (Coordinate(add(self.x, other.x),
                add(self.y, other.y))))
));

# @author SoundOfSpouting
Board = type("Board", (), dict(
  HEIGHT = 10,
  WIDTH = 10,

  # @author SoundOfSpouting
  __init__ = (lambda self:
    (setattr(self, "b", 0))),

  # @author SoundOfSpouting
  # @param {Coordinate} coord
  # @returns {boolean}
  at = (lambda self, coord:
    (eq(and_(rshift(self.b, add(mul(coord.getY(), Board.WIDTH), coord.getX())), 1), 1))),

  # @author SoundOfSpouting
  # @param {Coordinate} coord
  # @param {boolean} newVal
  # @returns {void}
  set = (lambda self, coord, newVal:
    (pos := coord.getY() * Board.WIDTH + coord.getX(),
     setattr(self, "b", or_(and_(self.b, invert(lshift(1, pos))), lshift(+newVal, pos))))),

  # @author SoundOfSpouting
  # @returns {bool}
  place = (lambda self, coord, num, dx = 0, dy = 0:
    (any(map((lambda i: self.at(coord.add(Coordinate(mul(i, dx), mul(i, dy))))),
             range(num))))
    or foreach(range(num), lambda i: self.set(Coordinate(mul(i, dx), mul(i, dy)), True))
    and None)
));

# @author SoundOfSpouting
# @returns {Coordinate[]}
place = (lambda:
  next(filter((lambda x: is_not(x, None)), iter(
    (lambda:
     (b := Board(),
      l := list(map((lambda num: (num, Coordinate(random.randint(0, 10), random.randint(0, 10)), random.choice([(0, 1), (1, 0)]))), range(5, 0, -1))),                     (
      None if not any(map((lambda t: b.place(t[1], t[0], *t[2])), l)) else list(map((lambda x: (x[0], x[2])), l))))                                                                              [-1]),
    0))));


# @author SoundOfSpouting
# @returns {string}
boom = (lambda:
  "\n".join(map((lambda x: Coordinate(*x)), product(range(Board.WIDTH), range(Board.HEIGHT)))));

main = (lambda:
  print("\n".join(map((lambda t: "%c%s" % ({(0, 1): "|", (1, 0): "-"}[t[1]], t[0])), place())),
        boom()))

main()
